package samples.filehandling;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

import static java.lang.System.out;

/**
 * Working with test files
 */
public class TextFiles {

      public static void main(String[] args) {
        new TextFiles().program();
    }

    void program() {
        List<String> orig = Arrays.asList("a", "b", "c", "d", "e");

        try {
            Path path = Paths.get("src/samples/filehandling/junk.txt");
            writeFile(path, orig);
            List<String> copy = readFile(path);
            boolean b = true;
            for( int i = 0 ; i < orig.size(); i++){
                b = b && orig.get(i).equals(copy.get(i));
            }
            out.println(b);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    List<String> readFile(Path path) throws IOException {
        List<String> lines = new ArrayList<>();
         // Use try with resources to ensure stream is closed
        try (BufferedReader reader = Files.newBufferedReader(path)) {
            String line;
            while ((line = reader.readLine()) != null) {
                lines.add(line);
            }
            reader.close();
            return lines;
        }
    }


    void writeFile(Path path, List<String> lines) throws IOException {
        try (BufferedWriter writer = Files.newBufferedWriter(path)) {
            for (String line : lines) {
                writer.write(line);
                writer.newLine();
            }
            writer.close();
        }
    }

}

