package pong.model;

import java.util.Random;

import static pong.model.Pong.BALL_DIAM;
import static pong.model.Pong.HEIGHT;
import static pong.model.Pong.WIDTH;

/*
 * A Ball for the Pong game
 */
public class Ball extends AbstractMovablePongObject {

    private static final Random rand = new Random();

    public Ball(double x, double y, double radius) {
        super(x, y, radius, radius, 0, 0);
        // Set somewhat random direction
        int[] dirs = {1, 2, 3 - 1, -2, -3};
        setDx(dirs[rand.nextInt(dirs.length)]);
        setDy(dirs[rand.nextInt(dirs.length)]);
    }

    public Ball(){
        this(WIDTH/2, HEIGHT/2, BALL_DIAM);
    }

    @Override
    public void move() {
        setX(getMinX() + getDx());
        setY(getMinY() + getDy());
    }

    public void bounceX() {
        setDx(-1 * getDx());
    }

    public void bounceY() {
        setDy(-1 * getDy());
    }

    public void incSpeed(double percent) {
        setDx((1 + percent / 100) * getDx());
        setDy((1 + percent / 100) * getDy());
    }

    public double getRadius() {
        return getWidth();
    }

}
