package samples.oo.inheritance;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import static java.lang.System.out;

/*
 *  Test inheritance
 */
public class TestInheritance {

    public static void main(String[] args) {
        new TestInheritance().program();
    }

    void program() {
        //Animal a = new Animal("Rosa", 4);     // No abstract

        Dog d = new Dog("Fido", 3);
        Cat c = new Cat("Missan",4, false);

        out.println(d);
        out.println(c);

        Animal a1 = d;  // Animal subset of operations of Dog
        Animal a2 = c;

        out.println(a1.getAge());
        out.println(a2.getAge());

        out.println(a1.say());
        out.println(a2.say());


        List<Animal> anims = new ArrayList<>(Arrays.asList(d, c));
        for( Animal a : anims){
            out.println(a.say());  // All animals can say
        }

        for( Animal a : anims){
            if( a instanceof Cat) {      // Is a a cat (or possibly some sub class of)
                out.println( ((Cat) a).isEvil());    // Ok
            }
        }
    }
}
